
package servidor;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.net.Socket;
import java.net.SocketTimeoutException;
import BaseDatos.ManejadorDB;
import java.sql.ResultSet;
import java.util.concurrent.TimeUnit;
import javax.swing.JOptionPane;



public class Atencion implements Runnable {
    private Socket socket;
    
    private BufferedReader in;
    private PrintStream    out;
    
    private boolean inicializado;
    private boolean ejecutando;
    public boolean listo; /* AVisa que ya e envio una denuncia */
    public boolean todo_enviado; /* Avisa que todos los datos fueron enviados*/
    
    private Thread thread;
    String Accion="";
    
       
    
    public Atencion (Socket socket) throws Exception {
        this.socket = socket;
        
        this.inicializado = false;
        this.ejecutando   = false;
        
        open();     
     }
    
    private void open() throws Exception {
        try {
            in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
            out = new PrintStream(socket.getOutputStream());
            inicializado = true;
         }
        catch (Exception e){
            close();
            throw e;
        }               
    }
    
    private void close() {
    if (in != null){
        try{
            in.close();
        }
        catch(Exception e){
            System.out.println(e);
        }
    }
    
    if (out!= null){
        try{
            out.close();
        }
        catch (Exception e){
            System.out.println(e);
        }
    }
    
    try {
        socket.close();
    }
    catch (Exception e){
        System.out.println(e);
    }
        
        in = null;
        out = null;
        socket = null;
        
        inicializado = false;
        ejecutando = false;
        
        thread = null;
     }
    
    public boolean get_listo(){
        return this.listo;
    }
    
    public boolean get_todo_enviado(){
        return this.todo_enviado;
    }
    
    public void toggle_listo(){
        this.listo=false;
    }
    
    public void toggle_todo_enviado(){
        this.todo_enviado=false;
    }
    
    public void start(){ /* Por cada cliente abre un hilo  */
        if(!inicializado || ejecutando) {
            return;
        }
        
        ejecutando = true;
        thread = new Thread (this);
        thread.start();
    }
    
    public void stop() throws Exception {
        ejecutando = false;
        
        if (thread != null){
        thread.join();
        }
    }
   
    
    public void run () {
        while (ejecutando){
            try {
                socket.setSoTimeout(2500);
                
                String mensaje = in.readLine();
                ManejadorDB manejador = new ManejadorDB();
                String respuesta = "";
                
                String[] mensajeDB = mensaje.split(",");
                Accion  =   mensajeDB[0];

                if(mensaje.equals("LISTO")) this.listo=true;
 
                System.out.println(
                        "Mensaje recibido de cliente [" +
                        socket.getInetAddress().getHostName() +
                        ":"+
                        socket.getPort() +
                        "] "+                               
                        mensaje);
                if("LISTO".equals(Accion)) listo=true;
                
               if ("BORRAR".equals(Accion)) 
               {
                   String Tabla     = mensajeDB[1];
                   String A_Borrar  = mensajeDB[2];
                   String Columna   = mensajeDB[4];
                   
                   manejador.Eliminar(A_Borrar,Tabla,Columna);
               }
               else if ("AGREGAR".equals(Accion)) 
               {
                   String Tabla     = mensajeDB[1];
                   respuesta = manejador.Agregar(mensajeDB,Tabla);
                   /*Agregados correctamente!"*/
                   /*"No se podido guardar la información!"*/                                 
               }             
               else if ("EDITAR".equals(Accion)) 
               {
                   String Tabla      = mensajeDB[1];
                   String A_Editar   = mensajeDB[2];
                   String Nuevo      = mensajeDB[3];
                   String Columna    = mensajeDB[4];
                   
                   manejador.Editar(A_Editar,Nuevo,Tabla,Columna);
               }     
               else if ("PASS".equals(Accion)) 
               {
                   String Tabla         = mensajeDB[1];
                   String Usuario       = mensajeDB[2];
                   String Contraseña    = mensajeDB[3];
                   
                   int Encontrado = manejador.Acceso_Usuario(Tabla,Usuario,Contraseña);
                   
                   if(Encontrado>0) {
                       respuesta = "Usuario y contraseña correctos!.";
                    //   JOptionPane.showMessageDialog(null,"SE ENCONTRO!");
                       
                   }
                   else respuesta = "Error Usuario / Contraseña!";
               }
               
               else if ("CONSULTAR".equals(Accion)) 
               {   int i=0;
                   String Tabla              = mensajeDB[1];
                   String Dato               = mensajeDB[2];
                   String Dato_Consultado    = mensajeDB[3];
                   ResultSet resultado = manejador.Consulta_Registro(Tabla, Dato,Dato_Consultado);
                   respuesta="TABLA =";


                 while(true){
                       if(i==0){                           
                               if(resultado.next()==false) {
                              respuesta="TABLA = , , , , , , , , , , ";
                              break;
                               }
                       } i++;
                      // "ID, Fecha","Hora","Empresa","Titulo Denuncia" 
                   respuesta +=String.valueOf(resultado.getInt(1))+","+resultado.getString(2)+","+resultado.getString(3)
                           +","+resultado.getString(4)+","+resultado.getString(5)+","+resultado.getString(6)
                           +","+resultado.getString(7)+","+resultado.getString(8)+","+
                                resultado.getString(9)+ ","+resultado.getString(10)+","+resultado.getString(11);

                    if((resultado.next())==true){                     
                     respuesta +="=";
                    }
                    else break;
                   } 

                   System.out.println("Respuesta!!!!= "+respuesta);

                   
               }
               else if("CREAR".equals(Accion))
               {
                    String Tabla  = mensajeDB[1];
                    manejador.Crear_Tabla(Tabla);
               }
               else if ("END".equals(Accion))
               {
                    break;
               }

            out.println(respuesta);
            }
            catch(SocketTimeoutException e){
                //ignorar
            }            
            catch(Exception e){
                out.println("ERROR!");
                System.out.println(e);
                break;
            }
                        
        }
        
        System.out.println("Cerrando Conexión.");
        close();
        
    }
    
    
    
    
    
    
}